#include "StdAfx.h"
#include ".\autofile.h"

CAutoFile::CAutoFile(CString fpath,FILE_TYPE ftype)
{
	m_Path = fpath;
	m_Type = ftype;

	if(m_Type == WRITE)
	{
		m_Success=file.Open( m_Path, CFile::modeCreate|CFile::modeWrite, NULL);
	}
	else
	{
		m_Success=file.Open( m_Path, CFile::modeRead|CFile::typeBinary,NULL);
	}
}



CAutoFile::~CAutoFile(void)
{
	if(m_Success == TRUE)
	   file.Close();
}





BOOL  CAutoFile::Read(void * lpBuf,UINT nCount)
{
	if((m_Type == WRITE)||(m_Success != TRUE))
		return FALSE;
    file.Read(lpBuf,nCount);
    return TRUE;
}




BOOL  CAutoFile::Write(void * lpBuf,UINT nCount)
{
	if((m_Type == READ)||(m_Success != TRUE))
		return FALSE;
	file.Write(lpBuf,nCount);
	return TRUE;
}







BOOL  CAutoFile::WriteLine(CString text)
{
	if((m_Type == READ)||(m_Success != TRUE))
		return FALSE;

	PBYTE  lpBuf;
	UINT   nCount;
	text=text+"\r\n\0";

	nCount = text.GetLength();
	lpBuf  = (PBYTE)text.GetBuffer(nCount);

	file.Write(lpBuf,nCount);

	text.ReleaseBuffer();

	return TRUE;
}










//==========================================================
//:  
//==========================================================
VOID  CAutoFile::BuildAll0x00File(CString name,UINT pagesize,UINT pagetotal)
{
	CAutoByteArray bytearry(pagesize);
	PBYTE pagebuff=bytearry.ptr;

	CFile memfile;	
	memfile.Open( name, CFile::modeCreate | CFile::modeWrite, NULL );
	for(UINT ab=0;ab<pagetotal;ab++)
	{
		for(UINT cc=0;cc<pagesize;cc++)
		{
			pagebuff[cc]=0x00;
		}
		memfile.Write(pagebuff,pagesize);
	}
	memfile.Close();
}



//==========================================================
//:  
//==========================================================
VOID  CAutoFile::BuildAll0xFFFile(CString name,UINT pagesize,UINT pagetotal)
{
	CAutoByteArray bytearry(pagesize);
	PBYTE pagebuff=bytearry.ptr;

	CFile memfile;	
	memfile.Open( name, CFile::modeCreate | CFile::modeWrite, NULL );
	for(UINT ab=0;ab<pagetotal;ab++)
	{
		for(UINT cc=0;cc<pagesize;cc++)
		{
			pagebuff[cc]=0xFF;
		}
		memfile.Write(pagebuff,pagesize);
	}
	memfile.Close();
}




//==========================================================
//:  
//==========================================================
VOID  CAutoFile::BuildSequenceFile(CString name,UINT pagesize,UINT pagetotal)
{
	CAutoByteArray bytearry(pagesize);
	PBYTE pagebuff=bytearry.ptr;
	BYTE data=0;
	CFile memfile;	
	memfile.Open( name, CFile::modeCreate | CFile::modeWrite, NULL );
	for(UINT ab=0;ab<pagetotal;ab++)
	{
		for(UINT cc=0;cc<pagesize;cc++)
		{				
			pagebuff[cc]=data;
			data++;
		}
		memfile.Write(pagebuff,pagesize);
	}
	memfile.Close();
}


//==========================================================
//:  
//==========================================================
VOID  CAutoFile::BuildRandomFile(CString name,UINT pagesize,UINT pagetotal)
{
	CAutoByteArray bytearry(pagesize);
	PBYTE pagebuff=bytearry.ptr;
	BYTE rtest;

	CFile memfile;	
	memfile.Open( name, CFile::modeCreate | CFile::modeWrite, NULL );
	for(UINT ab=0;ab<pagetotal;ab++)
	{
		for(UINT cc=0;cc<pagesize;cc++)
		{			
			rtest=rand();         //õֵ
			pagebuff[cc]=rtest;
		}
		memfile.Write(pagebuff,pagesize);
	}
	memfile.Close();
}



//==========================================================
//:  
//==========================================================
BOOL  CAutoFile::FileCompare(CString source,CString object,UINT pagesize,UINT pagetotal)
{
	CFile infile,outfile;

	CAutoByteArray bytearry1(pagesize);
	PBYTE inbuff=bytearry1.ptr;
	CAutoByteArray bytearry2(pagesize);
	PBYTE outbuff=bytearry2.ptr;

	infile.Open( source, CFile::modeRead|CFile::typeBinary,NULL);
	outfile.Open( object,CFile::modeRead|CFile::typeBinary,NULL);


	if(infile.GetLength()!=outfile.GetLength())
	{
		infile.Close();
		outfile.Close();
		return FALSE;
	}


	for(UINT zz=0;zz<pagetotal;zz++)
	{
		infile.Read(inbuff,pagesize);
		outfile.Read(outbuff,pagesize);
		for(UINT hh=0;hh<pagesize;hh++)
		{
			if(inbuff[hh]!=outbuff[hh])
				return FALSE;
		}
	}
	infile.Close();
	outfile.Close();

	return TRUE;
}
