// FishStatic.cpp : ʵļ
//

#include "stdafx.h"
#include "FishLink.h"


// CFishLink

IMPLEMENT_DYNAMIC(CFishLink, CWnd)

CFishLink::CFishLink()
{
   m_Text = "FISH";
   m_TextColor = RGB(0,255,0);
   m_OverTextColor = RGB(255,0,0);

   m_TextFontName = "Arial Black";
   m_FontWidth = 18;
   m_FontHeight = 9;
   m_TextFont = new CFont();
   m_TextFont->CreateFont(m_FontWidth,m_FontHeight,0,0,FW_NORMAL,FALSE,FALSE,FALSE,  
							ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,   
							DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS,m_TextFontName);


   m_BackGroundBrush = new CBrush(RGB(255,255,255));

   m_DisBackGroundBrush = new CBrush(RGB(174,174,174));
   m_DisTextColor = RGB(0,0,0);

   m_bOver = FALSE;
   m_bTracking = FALSE;
}

CFishLink::~CFishLink()
{
	ReleaseObject(m_DisBackGroundBrush);
	ReleaseObject(m_BackGroundBrush);
    ReleaseObject(m_TextFont);
}


BEGIN_MESSAGE_MAP(CFishLink, CWnd)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
	ON_MESSAGE(WM_MOUSEHOVER, OnMouseHover)
	ON_WM_SETCURSOR()
END_MESSAGE_MAP()



// CFishLink Ϣ



//===========================================================
//
//
//===========================================================
VOID  CFishLink::ReleaseObject(CGdiObject * object)
{
	if(object!=NULL)
	{
		object->DeleteObject();
		delete object;
	    object = NULL;
	}
}





//===========================================================
//
//
//===========================================================
VOID CFishLink::SetBackGroudColor(COLORREF color)
{
	ReleaseObject(m_BackGroundBrush);

	m_BackGroundBrush = new CBrush(color);

	Invalidate(FALSE);
}





//===========================================================
//
//
//===========================================================
VOID CFishLink::SetDisBackGroudColor(COLORREF color)
{
	ReleaseObject(m_DisBackGroundBrush);

	m_DisBackGroundBrush = new CBrush(color);

	Invalidate(FALSE);
}






//===========================================================
//
//
//===========================================================
VOID CFishLink::SetFontName(CString name)
{
	ReleaseObject(m_TextFont);

	m_TextFont = new CFont();
	m_TextFont->CreateFont(m_FontWidth,m_FontHeight,0,0,FW_NORMAL,FALSE,FALSE,FALSE,  
							ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,   
							DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS,m_TextFontName);

	Invalidate(FALSE);
}



//===========================================================
//
//
//===========================================================
VOID CFishLink::SetFontSize(UINT width,UINT height)
{
	ReleaseObject(m_TextFont);

	m_TextFont = new CFont();
	m_TextFont->CreateFont(m_FontWidth,m_FontHeight,0,0,FW_NORMAL,FALSE,FALSE,FALSE,  
							ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,   
							DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS,m_TextFontName);

	Invalidate(FALSE);
}



//===========================================================
//
//
//===========================================================
VOID CFishLink::SetTextColor(COLORREF color)
{	
	m_TextColor = color;

	Invalidate(FALSE);
}



//===========================================================
//
//
//===========================================================
VOID CFishLink::SetDisTextColor(COLORREF color)
{	
	m_DisTextColor = color;

	Invalidate(FALSE);
}


//===========================================================
//
//
//===========================================================
VOID CFishLink::SetOverTextColor(COLORREF color)
{	
	m_OverTextColor = color;

	Invalidate(FALSE);
}


//===========================================================
//
//
//===========================================================
VOID CFishLink::SetText(CString text)
{
	m_Text = text;

	Invalidate(FALSE);
}





//===========================================================
//
//
//===========================================================
void CFishLink::OnPaint()
{


	CPaintDC dc(this); 		
		
	// device context for painting
	// TODO: ڴ˴Ϣ
	// ΪͼϢ CWnd::OnPaint()

	CRect rcClient;
	GetClientRect(rcClient);
	CDC MemDC;
	if (!MemDC.CreateCompatibleDC(&dc))
		return;
	CBitmap m_Bitmap;
	if(!m_Bitmap.CreateCompatibleBitmap(&dc,rcClient.Width(),rcClient.Height()))
		return;
	BITMAP bm;
	m_Bitmap.GetBitmap(&bm);
	CBitmap* pOldBitmap = (CBitmap*) MemDC.SelectObject(&m_Bitmap);
	//CPen* pOldPen = MemDC.SelectObject(m_TextPen);
	CFont* pOldFont = MemDC.SelectObject(m_TextFont);



    if(IsWindowEnabled())
	{
		//ײ
		MemDC.FillRect(rcClient,m_BackGroundBrush);  
		//
		if(m_bOver)
		{
          MemDC.SetTextColor(m_OverTextColor);    /*ɫеɫ*/
		}
		else
		{
		  MemDC.SetTextColor(m_TextColor);    /*ɫеɫ*/
		}
	}
	else
	{
		//ײ
		MemDC.FillRect(rcClient,m_DisBackGroundBrush);  
		//
		MemDC.SetTextColor(m_DisTextColor);    /*ɫеɫ*/
	}


    MemDC.SetBkMode(TRANSPARENT);       /*ֵıΪ͸ֱΪϵͳĬɫ*/
    //pDC->SetBkColor(RGB(255,0,0));    /*ֵıɫעдĻɫЧ*/
	MemDC.DrawText(m_Text,-1,&rcClient,DT_RIGHT |DT_VCENTER|DT_SINGLELINE|DT_NOCLIP); //Ҷ



	dc.BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &MemDC, 0, 0, SRCCOPY);
	MemDC.SelectObject(pOldFont);
	//MemDC.SelectObject(pOldPen);
	MemDC.SelectObject(pOldBitmap);
}








void CFishLink::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (!m_bTracking)
	{
		TRACKMOUSEEVENT tme;
		tme.cbSize = sizeof(tme);
		tme.hwndTrack = m_hWnd;
		tme.dwFlags = TME_LEAVE | TME_HOVER;
		tme.dwHoverTime = 1;
		m_bTracking = _TrackMouseEvent(&tme);
	}	
	CWnd::OnMouseMove(nFlags,point);
}



LRESULT CFishLink::OnMouseLeave(WPARAM wParam, LPARAM lParam)
{
	//OutputDebugString("OnMouseLeave()\r\n");
	m_bOver = FALSE;
	m_bTracking = FALSE;
	Invalidate(FALSE);
	return 0;
}




LRESULT CFishLink::OnMouseHover(WPARAM wParam, LPARAM lParam)
{
	//OutputDebugString("OnMouseHover()\r\n");
	m_bOver = TRUE;
	Invalidate(FALSE);
	return 0;
}




void CFishLink::PreSubclassWindow()
{
	// TODO: ڴרô/û
	CWnd::PreSubclassWindow();

	//::SetClassLong(hWnd, GCL_HCURSOR, NULL); ޸Ĺ
	ModifyStyle(0, BS_OWNERDRAW);
}




BOOL CFishLink::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	// TODO: ڴϢ/Ĭֵ
	HCURSOR hCursor;
	if(m_bOver)
	{
        hCursor=::LoadCursor(NULL,IDC_HAND);	//̬޸Ĺ
	}
	else
	{
        hCursor=::LoadCursor(NULL,IDC_ARROW);   //̬޸Ĺ 
	}
	::SetCursor(hCursor);


	//return CWnd::OnSetCursor(pWnd, nHitTest, message);
	return TRUE;
}
