#include "StdAfx.h"
#include ".\r6card.h"

CR6Card::CR6Card(MEMORY_ENTRY_MODE mode)
{
	m_Mode = mode;
	if(m_Mode == NORFLASH)
	{
		EntryNorFlashMode();
	}
	else if(m_Mode == EEPROM512K)
	{
		Entry512KEepromMode();
	}
	else if(m_Mode == EEPROM8M)
	{
		Entry8MEepromMode();
	}
	else
	{
		EntrySensorMode();
	}
}

CR6Card::~CR6Card(void)
{
	if(m_Mode == NORFLASH)
	{
		ExitNorFlashMode();
	}
}








//==========================================================
// 
//
//==========================================================
BOOL  CR6Card::EntryNorFlashMode()
{
	OutputDebugString("CNdsCard::EntryNorFlashMode() \r\n");
    R6EntryNorFlashMode();
	return TRUE; 
}



//==========================================================
//   
//
//==========================================================
BOOL  CR6Card::ExitNorFlashMode()
{
	OutputDebugString("CNdsCard::ExitNorFlashMode() \r\n");
	R6ExitNorFlashMode();
	return TRUE; 
}








//==========================================================
//
//
//==========================================================
BOOL  CR6Card::EntrySensorMode()
{
	OutputDebugString("CNdsCard::EntrySensorMode() \r\n");
    R6EntrySensorMode();
	return TRUE; 
}








//==========================================================
//
//
//==========================================================
BOOL  CR6Card::Entry512KEepromMode()
{
	OutputDebugString("CNdsCard::Entry512KEepromMode() \r\n");
    R6Entry512KEepromMode();
	return TRUE;
}



//==========================================================
//  
//
//==========================================================
BOOL  CR6Card::Entry8MEepromMode()
{
	OutputDebugString("CNdsCard::Entry8MEepromMode() \r\n");
    R6Entry8MEepromMode();
	return TRUE;
}
